#ifndef BASICGA_H
#define BASICGA_H

#include <math.h>
#include <stdio.h>
#include "nstring.h"
#include "evaluator.h"
#include "narray.h"
#include "params.h"
#include "repres.h"
#include "genome.h"
#include "population.h"
class BasicGa : public Evaluator
{
protected:
    Repres repres;
    Params* params;
    Population* pop;

    int numEvals;
    bool showEval;
public:
    BasicGa(){ 
        params = 0;
        pop = 0;
        showEval = false;
    }
    ~BasicGa(){
        if( pop ) delete pop;
        if( params ) delete params;
    }
    void run();
    void show( char* bitString );
protected:
    virtual void initParams();
    virtual void loadParameters();
    virtual void parseParam( char* s );
    virtual void load();
    virtual void buildGenome();
    virtual void buildPopulation();
    virtual float eval( Genome* rhs );
    float evaluate( Genome* rhs );
    void showBest();
};
#endif
