#include "assert.h"
class BitTreeNode{
public:
    union{
        BitTreeNode* kids[2];
        float value;
    };
    BitTreeNode(){
        kids[0] = NULL;
        kids[1] = NULL;
    }
    BitTreeNode* createKid( int i ){
        assert( i == 0 || i == 1 );
        if( kids[i] ) 
            return kids[i];
        else{
            BitTreeNode* node = new BitTreeNode();
            if( node == NULL )
                printf("node creation failed\n");
            else
                kids[i] = node;
            return node;
        }
    }
    BitTreeNode* findKid( int i ){
        assert( i == 0 || i == 1 );
        if( kids[i] )
            return kids[i];
        else
            return NULL;
    }
};

class BitTree
{
    int depth;
    BitTreeNode* root;
public:
    BitTree(){ root = new BitTreeNode(); }
    BitTree( int i ):
        depth( i ){ 
            printf("build a bitree of size %i\n", i );
            assert( depth >= 0);
            root = new BitTreeNode();
        }
    void setDepth( int i ){ 
        assert( i > 0 );
        depth = i; 
    }

    void insert( int* bits, float val ){
        BitTreeNode* node = root;
        int i;
        for( i = 0; i < depth; i ++ ){
            assert( bits[i] == 0 || bits[i] == 1 );
            node = node->createKid( bits[i] );
        }
        node->value = val;
    }
    bool find( int* bits, float& val ){
        BitTreeNode* node = root;
        for( int i = 0; node && i < depth; i ++ ){
            assert( bits[i] == 0 || bits[i] == 1 );
            if( node != NULL )
                node = node->findKid( bits[i] );
            else
                return false;
        }
        if( node )
            val = node->value;
        else
            return false;
    }
};

