#ifndef EVAL_H
#define EVAL_H
#include <stdlib.h>
inline int irand( int max ){
    return (int) (float(max+1)*rand()/(RAND_MAX+1.0));
}
inline int irand( int min, int max ){
    return min + (int)(float(max+1-min) * rand()/(RAND_MAX+1.0));
}
inline float frand( float max ){
    return ((max) * rand()/(RAND_MAX+1.0));
}
inline float frand( float min, float max ){
    return min + ((max-min) * rand()/(RAND_MAX+1.0));
}
inline bool roll( float prob ){
    return (float(rand()) / (RAND_MAX+1.0)) < prob;
}
inline void swap( int& a, int& b ){
    int t = a;
    a = b;
    b = t;
}
class Genome;
class Evaluator
{
public:
    virtual float evaluate( Genome* g ) { return 0.0f; }
};
#endif
