#ifndef PARAMS_H
#define PARAMS_H
#include "evaluator.h"
#include <stdio.h>
#include "bittree.h"
class Repres;
class Genome;
enum SelectionType
{
    SELECTION_ROULETTE,
    SELECTION_CHC,
};
class Params
{
public:
    SelectionType selectionType;

    int popSize;
    int numGens;
    int genomeLength;
    float mutationProb;
    float crossoverProb;
    int elitists;
    float avgMappedFitness;
    float maxMappedFitness;
    int randomSeeds;
    bool memetic;
    float quality;

    Repres* repres;
    char* toString(){
        sprintf( string, "pop: %i gens:%i mutProb:%.2f crossProb:%.2f showEvery: %i", popSize, numGens, mutationProb, crossoverProb, showEvery );
        return string;
    }
    char string[1024];
    Evaluator* evaluator;
    BitTree* bitTree;
    int showEvery;
    int logEvery;

    Params(){
        popSize = 10;
        numGens = 10;
        genomeLength = 0;
        mutationProb = .01;
        crossoverProb = .7;
        elitists = 0;
        maxMappedFitness = 2.0f;
        randomSeeds = 0;
        logEvery = 1;
        memetic = false;
        quality = 0.0f;
        repres = 0;
        evaluator = 0;
        bitTree = 0;
    }
};
    
#endif
