#ifndef POPULATION_H
#define POPULATION_H
#include "genome.h"
#include "repres.h"
#include "stats.h"
class Population
{
protected:
    Params* params;
    nArray<Genome*> genomes[2];
    nArray<Genome*> sortedGenomes[2];
    nArray<Genome*> bothPopulations;
    int generation;
    //char string[10000];
    Stats fitnessStats;
    Stats mappedFitnessStats;
    StatStats genFitnessStats;
    int z;
public:
    Population();
    virtual void setParams( Params* params );
    virtual void initialize();
    virtual nArray<nString> toStrings();
    virtual void eval();
    virtual void runGeneration();
    virtual void mapFitnesses();
    virtual void mapFitness( Genome* g );
    virtual void selection();
    virtual void sortPopulation();
    virtual void crossover();
    virtual void mutation();
    virtual void memetic();
    virtual void logData();
    virtual void logGenStats();
    Genome* genome( int index ){
        return genomes[z][index];
    }
    Genome& operator[]( int index ){ return *genomes[z][index]; }
    virtual void randDuplicate();
    virtual void sortBothPopulations();
    virtual void keepBest();
};
    
#endif
