#ifndef STATS_H
#define STATS_H
#include <limits.h>

class Stats
{
    nArray<float> values;
public:
    float min, max, avg, mean, mode, range, minrange, maxrange;
    int minpos;
    int maxpos;
    int avgpos;
    int meanpos;
    int modepos;

    float sum;
    int n;
    void add(float f, int pos){
        values.Append( f );
        n++;
        if( f < min ) {
            min = f;
            minpos = pos;
            range = max - min;
        }
        if( f > max ) {
            max = f;
            maxpos = pos;
            range = max - min;
        }
        if( n == 0 )    avg = f;
        else            avg = avg * float(n-1) / float(n) + f / float(n);
        //MEAN - Need sorted list
        mean = 0;
        //MODE - Sorted list, or some kinda hash
        mode = 0;
        //SUM
        sum += f;
        minrange = avg - min;
        maxrange = max - avg;
    }
    void clear(){
        n = 0;
        values.Clear();
        min = LONG_MAX;
        max = LONG_MIN;
        avg = 0;
        mean = 0;
        mode = 0;
        sum = 0;
    }
    nString toString(){
        char answer[1024];
        sprintf( answer, "min: %f max: %f avg: %f", min, max, avg );
        return nString( answer );
    }
};

class StatStats
{
    nArray< Stats > values;
public:
    void add( Stats s ) {
        values.Append( s );
    }
#define getFunc(var)\
    nArray<nString> var(){\
        char string[1024];\
        nArray<nString> strings;\
        for( int i = 0; i < values.Size(); i ++ ){\
            sprintf(string, "%i %.2f\n", i, values[i].var );\
            strings.Append( string );\
        }\
        return strings;\
    }
        
    getFunc( avg )
    getFunc( min )
    getFunc( max )
    getFunc( mean )
    getFunc( mode )
    getFunc( sum )
};
#endif
