#include "ga.h"
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <wait.h>
#include <fcntl.h>
#include "ga.h"
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <wait.h>
#include <fcntl.h>
//#define params ((TspParams*)params)
void Ga::initParams(){
    BasicGa::params = params = new TspParams;
}
    
void Ga::parseParam( char* line ){
    BasicGa::parseParam( line );
    char param[1024];
    char string[1024];
    if( sscanf( line, "%s %s", &param, &string ) == 2 ){
        if( strcmp( param, "problem" )  == 0 ) params->problem = string;
        if( strcmp( param, "shiftprob") == 0 ) assert( sscanf( line, "%s %f", &param, &params->shiftProb ) == 2);
    }
}

void Ga::load(){
    loadGraph();
}

void Ga::loadGraph(){
    params->graph = &graph;
    printf("loading %s\n", params->problem.Get() );
    FILE* file = fopen( params->problem.Get(), "r" );
    if( file == 0 ){
        printf("failed to open %s\n", params->problem.Get() );
        return;
    }
    char line[1024];
    char string[2][1024];
    nString name;
    nString comment;
    nString type;

    while( fgets( line, 1024, file ) ){
        if( sscanf( line, "%s : %s\n", &string[0], &string[1] ) == 2 ||
            sscanf( line, "%s: %s\n",  &string[0], &string[1] ) == 2 ){
            printf("%s->%s\n", string[0], string[1]);
            if( nString(string[0]) == "NAME" )      name = string[1];
            if( nString(string[0]) == "COMMENT" )   comment = string[1];
            if( nString(string[0]) == "TYPE" )      type = string[1];
            if( nString(string[0]) == "DIMENSION" ) {
                params->numNodes = atoi( string[1] );
                printf("numnodes = %i\n", params->numNodes );
                graph.initialize( params->numNodes );
            }
            if( nString(string[0]) == "EDGE_WEIGHT_TYPE")       type = string[1];
        }
        if( sscanf( line, "%s\n", &string[0] ) == 1 ){
            if( nString(string[0]) == "NODE_COORD_SECTION"){
                int id, x, y;
                while( id < params->numNodes && fgets( line, 1024, file ) ){
                    if( sscanf( line, "%i %i %i", &id, &x, &y ) == 3 )
                        graph.addNode( id, x, y );
                }
            }

        }
    }
}

void Ga::buildGenome(){
    params->genomeLength = params->numNodes;
    //params->bitTree = new BitTree( params->genomeLength );
}

void Ga::buildPopulation(){
    pop = new TspPopulation();
    pop->setParams( params );
    pop->initialize();
}

float Ga::eval( Genome* g ){
    numEvals++;
    if( showEval ){
        printf("evaluating %s\n", g->toString().Get() );
        assert( g->isvalid() );
    }
    //repres.startParse( g );
    int from, to;
    from = g->bits[params->genomeLength-1];
    float tourCost = 0.0f;
    for( int i = 0; i < params->genomeLength; i ++ ){
        int to = g->bits[i];
        assert( from < params->genomeLength && from >= 0 );
        assert( to < params->genomeLength && to >= 0 );
        float edgeCost = rint( graph.cost( from, to ) );
        tourCost += edgeCost;
        if( showEval )
            printf("%i->%i $%f\n", from, to, edgeCost );
        from = to;
    }
    //repres.stopParse();
    if( showEval )
        printf("fit : %f\n", tourCost );
    if( tourCost <= params->quality ){
        FILE* file = fopen("logs/quality", "a" );
        fprintf(file, "%i\n", numEvals );
        fclose( file );
        exit(0);
    }
    return -tourCost;
}
