#ifndef GRAPH_H
#define GRAPH_H
#define sqr(x) ((x)*(x))
#include <math.h>
class Node
{
public:
    int id, x, y;
    Node(){
        x = y = -1;
    }
    void set( int id, int x, int y ){
        this->id = id;
        this->x = x;
        this->y = y;
    }
};
class Graph
{
protected:
    int n;
    Node* nodes;
    float** costMatrix;
    int c;

public:
    Graph(){
        n = 0;
        nodes = 0;
        costMatrix = 0;
        c = 0;
    }
    ~Graph(){
        if( nodes )
            delete[] nodes;
        if( costMatrix ){
            for( int i = 0; i < n; i ++ )
                delete[] costMatrix[i];
            delete[] costMatrix;
        }
    }
    void initialize( int n ){ 
        this->n = n;
        nodes = new Node[n];
        costMatrix = new float*[n];
        for( int i = 0; i < n; i ++ ){
            costMatrix[i] = new float[n];
            for( int j = 0; j < n; j ++ )
                costMatrix[i][j] = -1.0f;
        }
    }
    int size(){ return n; }
    inline float dist( int a, int b ){
        return sqrt( sqr( nodes[a].x - nodes[b].x ) + 
                     sqr( nodes[a].y - nodes[b].y ) );
    }

    inline float cost( int a, int b ){
        return costMatrix[a][b];
    }
    void addNode( int id, int x, int y ){
        nodes[c].set( id, x, y );
        for( int i = 0; i <= c; i ++ )
            costMatrix[i][c] = costMatrix[c][i] = dist( i, c );
        c++;
    }
};
#endif
