#ifndef GENOME_H
#define GENOME_H
#include <stdlib.h>
#include "params.h"
#include "nstring.h"
class Genome
{
protected:
    Params* params;
public:
    int* bits;
    float fitness;
    float mappedFitness;
    float lastSlot;
    bool evaluated;

    Genome();
    ~Genome();
    virtual void initialize();
    virtual void randomize();
    virtual void mutate();
    virtual void crossoverWith( Genome *rhs );
    virtual nString toString();
    virtual void fromString( const char* s );
    virtual void memetic();

    void setParams( Params* params );
    void operator = ( const Genome& rhs );
    void set ( const Genome& rhs ){ *this = rhs; }
    bool operator > ( const Genome& rhs ){ 
        assert(evaluated);
        assert(rhs.evaluated);
        return fitness > rhs.fitness; 
    }
    bool operator < ( const Genome& rhs ){ 
        assert(evaluated);
        assert(rhs.evaluated);
        return fitness < rhs.fitness; 
    }
    virtual bool isvalid(){
        for( int i = 0; i < params->genomeLength; i ++ )
            if ( !( bits[i] == 0 || bits[i] == 1 ) )
                return false;
        return true;
    }
                
    void eval();
};
#endif
