import java.util.Vector;
import java.awt.*;
import javax.swing.*;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.table.*;

class Genome
{
    public int generation;
    public float fitness;
    public float mfitness;
    //public int bits[];
    public String bits;
    public Genome( int generation, float fitness, float mfitness, String bitString ){
        this.generation = generation;
        this.fitness = fitness;
        this.mfitness = mfitness;
        this.bits = bitString;
        /*
        bits = new int[bitString.length()];
        for( int i = 0; i < bitString.length(); i ++ ){
            bits[i] = c.toInt( bitString.substring( i,i ) );
            System.out.println( "bits[" + i + "] = " + bits[i] );
        }
        */
    }
}

class GenomeData extends AbstractTableModel
{
    String mode;
    Vector genomesDisplayed;
    Vector genomes;
    Vector bestGenomes;
    Vector improvements;
    int highestGen;
    float bestFitness;
    public GenomeData(){ 
        genomes = new Vector();
        bestGenomes = new Vector();
        improvements = new Vector();
        highestGen = -1;
        bestFitness = -10000000.0f;
        mode = "none";
        setMode( "all");
    }
    public int getRowCount() { 
        return genomesDisplayed.size();
    }
    public int getColumnCount(){ return 4; }
    public Object getValueAt( int row, int column )
    {
        Genome g = null;
        g = (Genome) genomesDisplayed.get( row );
        switch( column ){
            case 0: return new Integer( g.generation );
            case 1: return new Float(   g.fitness );
            case 2: return new Float(   g.mfitness );
            case 3: return              g.bits;
        }
        return null;
    }
    public void add( int generation, float fit, float mfit, String bitString ){
        Genome g = new Genome( generation, fit, mfit, bitString );
        if( generation >= highestGen )
            genomes.add( g );
        if( generation > highestGen ){
            bestGenomes.add( g ) ;
            highestGen = generation;
        }
        if( fit > bestFitness ){
            improvements.add( g );
            bestFitness = fit;
        }
        fireTableRowsInserted( genomes.size()-1, genomes.size() );
    }
    public Class getColumnClass( int index ){
        try {
        switch( index ){
            case 0: return Class.forName("java.lang.Integer");
            case 1: return Class.forName("java.lang.Float");
            case 2: return Class.forName("java.lang.Float");
            case 3: return Class.forName("java.lang.String");
        }
        }
        catch( java.lang.ClassNotFoundException e ){
            e.printStackTrace();
        }
        return null;
    }
    public String getColumnName( int column ){
        switch( column ){
            case 0: return "gen";
            case 1: return "fit";
            case 2: return "mfit";
            case 3: return "bits";
        }
        return null;
    }
    public Genome get( int i ){
        return (Genome) genomesDisplayed.get( i );
    }
    public void setMode( String s ){
        System.out.println( "genomes.setmode( " + s + ")" );
        if( !mode.equals(s)){
            mode = s;
            if( mode.equals("all") )
                genomesDisplayed = genomes;
            else if( mode.equals("best") )
                genomesDisplayed = bestGenomes;
            else if( mode.equals("improvements") ){
                System.out.println(" mode : improvements" );
                genomesDisplayed = improvements;
            }

            fireTableStructureChanged();
        }
    }
}
            
public class Genomes extends JPanel
{
    GenomeData data;
    JTable table;
    public Genomes(){
        data = new GenomeData();
        table = new JTable( data );
        table.setPreferredScrollableViewportSize( new Dimension( 600,600 ) );
        updateColumnWidths();
        
        JScrollPane scrollPane = new JScrollPane( table );
        table.doLayout();
        //scrollPane.setPreferredSize( new Dimension ( 500, 500 ) );
        add( scrollPane );
    }
    public void updateColumnWidths(){
        TableColumn column = null;
        for( int i = 0; i < 4; i ++ ){
            column = table.getColumnModel().getColumn(i);
            if( i == 0 )  column.setMaxWidth( 50 );
            if( i == 1 )  column.setMaxWidth( 50 );
            if( i == 2 )  column.setMaxWidth( 50 );
        }
    }

    public void add( int generation, float fit, float mfit, String bitString ){ 
        data.add( generation, fit, mfit, bitString );
    }
    public String getSelected(){
        Genome g = data.get( table.getSelectedRow() );
        if( g == null ) return null;
        return g.bits;
    }
    public void viewAll(){
        data.setMode( "all" );
        updateColumnWidths();
    }
    public void viewBest(){
        data.setMode( "best");
        updateColumnWidths();
    }
    public void viewImprovements(){
        data.setMode( "improvements");
        updateColumnWidths();
    }
}
